"""Initial version.

Revision ID: b7454bc8b0b2
Revises:
Create Date: 2016-10-31 12:36:36.488736

"""

# revision identifiers, used by Alembic.
revision = 'b7454bc8b0b2'
down_revision = None
branch_labels = None
depends_on = None

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('example',
    sa.Column('data', sa.LargeBinary(), nullable=True),
    sa.Column('test', sa.Text(), nullable=True),
    sa.Column('pk', sa.String(length=32), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.Column('user', sa.String(length=32), nullable=True),
    sa.ForeignKeyConstraint(['user'], ['user.pk'], name='example_user_user', ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('pk'),
    sa.UniqueConstraint('user', name='unique_example_user')
    )
    op.create_index(op.f('ix_example_created_at'), 'example', ['created_at'], unique=False)
    op.create_index(op.f('ix_example_pk'), 'example', ['pk'], unique=False)
    op.create_index(op.f('ix_example_updated_at'), 'example', ['updated_at'], unique=False)
    op.create_index(op.f('ix_example_user'), 'example', ['user'], unique=False)
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_example_user'), table_name='example')
    op.drop_index(op.f('ix_example_updated_at'), table_name='example')
    op.drop_index(op.f('ix_example_pk'), table_name='example')
    op.drop_index(op.f('ix_example_created_at'), table_name='example')
    op.drop_table('example')
    ### end Alembic commands ###
